PROGRAM XNS
  ! This progam compute a NS model for a given quatity od interest
  ! (central density, barionic mass, gravit mass, etc...)
  ! It invokes XNSMAIN that computer a NS moddel for a given central density
  ! This is done repeatedly with Newton scheme where the solution having the
  ! desired property is serched for.

#ifdef MPIV
  use mpi
#endif  
  
  USE SYSTEMXNS
  IMPLICIT NONE
  
  REAL :: DF, F1, F2, FR, FL
  REAL :: DRHO,DRHOOLD
  REAL :: QUA,QUB,QUR,QUL
  REAL :: RHOVAR,RHOMAX, RHOMIN
  INTEGER :: NRHOINI, num1,num2

  INTEGER :: ERR
  INTEGER :: ICOUNT,ICOUNT0,IRATE,J,ILOOP
  REAL :: SECS

#ifdef MPIV
  INTEGER :: comm, myid, nprocs, id2send
  INTEGER :: mpierr,mpireal
  INTEGER :: status(MPI_STATUS_SIZE)

  REAL, DIMENSION(3) :: wsend,wrecv
  REAL :: omgmax, omgmin, domg, nomg
  REAL :: kbmax, kbmin, dkb, nrho, nkb
  REAL :: rhosend, kbpsend, omgsend
  
  CHARACTER(len=10) :: name1, name2, name3
  CHARACTER(len=50) :: command
  
  LOGICAL :: lcontinue
#endif
  
  ! Check for consistency  
  IF((ITOR.AND.IPOL).OR.(ITOR.AND.ITWT).OR.(IPOL.AND.ITWT))THEN
    WRITE(6,*)'Logical parameters for the magnetic structure are conflicting'
    WRITE(6,*)'Only one can be set .true.'
    STOP
  END IF
  IF(IPOL.AND.DIFFERENTIAL) THEN
    WRITE(6,*)'WARNING: differential rotation with poloidal magnetic not implemented.'
    STOP 
  ENDIF
  IF(ITWT.AND.OMG.NE.0) THEN
    WRITE(6,*)'WARNING:rotation together with magnetic mixed field not implemented.'
    STOP  
  ENDIF
  IF(CUT.LT.1) THEN
     WRITE(6,*)'WARNING: the parameter -CUT- should not be less than 1'
  ENDIF
     
  ! Start counting system time for log file
  CALL SYSTEM_CLOCK(ICOUNT0)


#ifdef NWTRPS

  IF(QUOC.LT.0 .OR. QUOC .GT. 2) THEN
    WRITE(6,*)'WARNING: please select a quantity for the convergence'
    WRITE(6,*)'the Newton-Raphson scheme:'
    WRITE(6,*)'QOFC=0 -> central density'
    WRITE(6,*)'QOFC=1 -> gravitational mass'
    WRITE(6,*)'QOFC=2 -> baryonic mass'
  ENDIF
  
  IDAT=.FALSE.
  SUBDIRPATH=''
  RHOVAR=RHOINI

  !Range of density over which to look for solutions (+/- 20%)
  RHOMAX = RHOVAR + 0.2*RHOVAR 
  RHOMIN = RHOVAR - 0.2*RHOVAR

  !Check if density range is OK
  WRITE(6,*), 'Checking the initial central density range...'
  CALL XNSMAIN(RHOMAX,QUR)
  CALL XNSMAIN(RHOMIN,QUL)
  FL=QUCONV-QUL
  FR=QUCONV-QUR

  IF(FL*FR .GT. 0)THEN
     IF(QUOC .EQ. 0)THEN
        WRITE(6,*)'Solution is outside the initial  central density range ',RHOMIN,' - ',RHOMAX
        WRITE(6,*)'Selectc a new initial central density or a larger range'
        WRITE(6,*)'At central density = ',RHOMIN,' the quantity is = ',QUL 
        WRITE(6,*)'At central density = ',RHOMAX,' the quantity is = ',QUR 
        STOP
     ELSE
        WRITE(6,*)'Solution might be a local maxima/minima in the density range ',RHOMIN,' - ',RHOMAX
        WRITE(6,*)'Selectc another variable for convergence'
        WRITE(6,*)'At central density = ',RHOMIN,' the quantity is = ',QUL 
        WRITE(6,*)'At central density = ',RHOMAX,' the quantity is = ',QUR
        STOP
     END IF
  END IF

  !Compute the quantity of interest for the initial guess density
  CALL XNSMAIN(RHOVAR,QUA)
  F1 = QUCONV-QUA
  J=1
  WRITE(6,*)'Iter = ',J,', Quantity  =', QUA

  !Compute the numerical derivative with respect to the initial guess density
  CALL XNSMAIN(RHOVAR*1.0001,QUB)
  F2 = QUCONV-QUB
  DF = (F2 - F1)/(RHOVAR*0.0001)

  DRHO=RHOMAX-RHOMIN
  DRHOOLD=DRHO

  !WRITE(6,*) RHOVAR
  DO J =2, NVALUE
      ! Remain within a bounded search domain
     IF((((RHOVAR-RHOMIN)*DF-F1)*((RHOVAR-RHOMAX)*DF-F1) .GT. 0) &
        .OR. (ABS(2.*F1) .GT. ABS(DRHOOLD*DF))) then
        DRHOOLD=DRHO
        DRHO=0.5*(RHOMAX - RHOMIN)
        RHOVAR= RHOMIN+0.5*DRHO
        !WRITE(6,*)'a',rhovar
     ELSE 
        DRHOOLD = DRHO
        DRHO= F1/DF
        RHOVAR=RHOVAR-DRHO
        !WRITE(6,*)'b',rhovar
     END if
     
     CALL XNSMAIN(RHOVAR,QUA)   
     F1 = QUCONV-QUA
     !WRITE(6,*)'c',rhovar
     WRITE(6,*)'Iter = ',j,', Quantity =', QUA,QUCONV,F1
     
     IF(ABS(F1)/QUCONV .LT. CONVF)THEN
        IDAT=.TRUE.
        CALL XNSMAIN(RHOVAR,QUA)
        WRITE(6,*)''
        WRITE(6,*)'End of Run - Num. iterations = ',J
        WRITE(6,*)'Desired value = ',QUCONV
        WRITE(6,*)'Obtained value = ',QUA
        WRITE(6,*)'Corresponding central density in XNSMAIN = ',RHOVAR
        EXIT
     END IF
     !Compute the numerical derivative 
     CALL XNSMAIN(RHOVAR*1.0001,QUB)

     F2 = QUCONV-QUB
     DF= (F2 - F1)/(RHOVAR*0.0001)
     
     ! Bound the domain of search
     IF(F1 .GT. 0) RHOMIN=RHOVAR
     IF(F1 .LT. 0) RHOMAX=RHOVAR
  END DO
  
#elif MPIV

  LCONTINUE=.TRUE.
  
  CALL MPI_INIT(mpierr)
  CALL MPI_COMM_SIZE(comm,nprocs,mpierr)
  CALL MPI_COMM_RANK(comm,myid,mpierr)

  if (kind(1.0)==4) mpireal=mpi_real
  if (kind(1.0)==8) mpireal=mpi_double_precision

  KBMIN =0.0   ; KBMAX =0.4
  RHOMIN=1.e-4 ; RHOMAX=1.e-3
  OMGMIN=0.01  ; OMGMAX=0.1

  NKB = 4.
  NRHO= 10.
  NOMG= 5.

  DRHO=(RHOMAX-RHOMIN)/NRHO
  DKB =(KBMAX-KBMIN)/NKB
  DOMG=(OMGMAX-OMGMIN)/NOMG

  RHOSEND=RHOMIN
  KBPSEND=KBMIN
  OMGSEND=OMGMIN

  !send the first chunck of initial conditions to the other tasks
  if(myid.EQ.0) then
    do j=1,nprocs-1 
      RHOSEND=RHOSEND+DRHO
      if(RHOSEND.gt.RHOMAX) then
        RHOSEND=RHOMIN
        KBPSEND=KBMIN+DKB
        if(KBPSEND.gt.KBMAX) THEN
          KBPSEND=KBMIN
          OMGSEND=OMGSEND+DOMG 
        endif
        if(OMGSEND.gt.OMGMAX) LCONTINUE=.FALSE.
      endif
      WSEND=[RHOSEND,KBPSEND,OMGSEND]
      print*, 'sending to', j, wsend
      call MPI_SEND(wsend,3,mpireal,j,10,mpi_comm_world,mpierr)
    end do

    !iterate till completion
    do while(LCONTINUE)
      RHOSEND=RHOSEND+DRHO
      if(RHOSEND.gt.RHOMAX) then
        RHOSEND=RHOMIN
        KBPSEND=KBPSEND+DKB
        if(KBPSEND.gt.KBMAX) THEN
          KBPSEND=KBMIN
          OMGSEND=OMGSEND+DOMG 
        endif
        if(OMGSEND.gt.OMGMAX) then
          LCONTINUE=.FALSE.
          RHOSEND=-1.
        endif  
      endif
      wsend=[RHOSEND,KBPSEND,OMGSEND]
      !receive id of the free task and send new data
      print*,'wsend',wsend
      call MPI_RECV(id2send,1,mpi_integer,mpi_any_source,20,comm,status,mpierr)
      call MPI_SEND(wsend,3,mpi_real,id2send,30,comm,mpierr)
    end do
   
    call mpi_finalize(err)
    
  else
     !Receive first chunk of initial conditions
     call MPI_RECV(wrecv,3,mpireal,0,10,mpi_comm_world,status,mpierr)
     RHOVAR=wrecv(1) 
   ! if(ITOR) KBTOR=wrecv(2)
   ! if(IPOL) KBPOL=wrecv(2)
   ! if(ITWT) KBTWT=wrecv(2)
   ! OMG=wrecv(3)

    !make folder to write data
    WRITE(name3,'(ES10.4)') wrecv(1)
    WRITE(name2,'(ES10.3)') wrecv(2)
    WRITE(name1,'(ES10.3)') wrecv(3)
    SUBDIRPATH='omg'//trim(adjustl(name1))//'/mag'//trim(adjustl(name2))//'/rho'//trim(adjustl(name3))
    command='mkdir -p '//SUBDIRPATH
    !CALL EXECUTE_COMMAND_LINE(command)
    CALL SYSTEM(command)
    
    !CALL XNSMAIN(RHOVAR,QUA)

    !send id to root and receive new initial conditions
    do
      call MPI_SEND(myid,1,mpi_integer,0,20,comm,mpierr)
      call MPI_RECV(wrecv,3,mpi_real,0,30,comm,status,mpierr)
      RHOVAR=wrecv(1)
      if(RHOVAR.lt.0.) exit
      !if(ITOR) KBTOR=wrecv(2)
      !if(IPOL) KBPOL=wrecv(2)
      !if(ITWT) KBTWT=wrecv(2)
      !OMG=wrecv(3)
      
      WRITE(name3,'(ES10.4)') wrecv(1)
      WRITE(name2,'(ES10.3)') wrecv(2)
      WRITE(name1,'(ES10.3)') wrecv(3)
      SUBDIRPATH='omg'//trim(adjustl(name1))//'/mag'//trim(adjustl(name2))//'/rho'//trim(adjustl(name3))
      command='mkdir -p '//SUBDIRPATH
      !CALL EXECUTE_COMMAND_LINE(command)
      CALL SYSTEM(command)
      
      !CALL XNSMAIN(RHOVAR,QUA)
    enddo
   
    call mpi_finalize(err)

   endif

#else 
  
  IDAT=.TRUE.
  SUBDIRPATH=''
  RHOVAR=RHOINI
  CALL XNSMAIN(RHOVAR,QUA)
  
#endif

 ! System clock
 CALL SYSTEM_CLOCK(ICOUNT,IRATE)
 SECS=FLOAT(ICOUNT-ICOUNT0)/FLOAT(IRATE)
 PRINT '(1X,A,F10.2)','CPU time (sec):',SECS

END PROGRAM XNS


